diff --git a/src/backend/utils/adt/pgstatfuncs.c b/src/backend/utils/adt/pgstatfuncs.c
index ff5aedc99c..aa7dde3688 100644
--- a/src/backend/utils/adt/pgstatfuncs.c
+++ b/src/backend/utils/adt/pgstatfuncs.c
@@ -567,7 +567,7 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 Datum
 pg_stat_get_activity(PG_FUNCTION_ARGS)
 {
-#define PG_STAT_GET_ACTIVITY_COLS	30
+#define PG_STAT_GET_ACTIVITY_COLS	34
 	int			num_backends = pgstat_fetch_stat_numbackends();
 	int			curr_backend;
 	int			pid = PG_ARGISNULL(0) ? -1 : PG_GETARG_INT32(0);
@@ -916,6 +916,10 @@ pg_stat_get_activity(PG_FUNCTION_ARGS)
 				nulls[29] = true;
 			else
 				values[29] = UInt64GetDatum(beentry->st_query_id);
+			values[30] = beentry->st_rx_raw_bytes;
+			values[31] = beentry->st_tx_raw_bytes;
+			values[32] = beentry->st_rx_compressed_bytes;
+			values[33] = beentry->st_tx_compressed_bytes;
 		}
 		else
 		{
@@ -944,6 +948,10 @@ pg_stat_get_activity(PG_FUNCTION_ARGS)
 			nulls[27] = true;
 			nulls[28] = true;
 			nulls[29] = true;
+			nulls[30] = true;
+			nulls[31] = true;
+			nulls[32] = true;
+			nulls[33] = true;
 		}
 
 		tuplestore_putvalues(tupstore, tupdesc, values, nulls);
@@ -1143,6 +1151,46 @@ pg_stat_get_backend_start(PG_FUNCTION_ARGS)
 	PG_RETURN_TIMESTAMPTZ(result);
 }
 
+Datum
+pg_stat_get_network_traffic(PG_FUNCTION_ARGS)
+{
+#define PG_STAT_NETWORK_TRAFFIC_COLS	4
+	TupleDesc	tupdesc;
+	Datum		values[PG_STAT_NETWORK_TRAFFIC_COLS];
+	bool		nulls[PG_STAT_NETWORK_TRAFFIC_COLS];
+	int32		beid = PG_GETARG_INT32(0);
+	PgBackendStatus *beentry;
+
+	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+		PG_RETURN_NULL();
+	else if (!HAS_PGSTAT_PERMISSIONS(beentry->st_userid))
+		PG_RETURN_NULL();
+
+	/* Initialise values and NULL flags arrays */
+	MemSet(values, 0, sizeof(values));
+	MemSet(nulls, 0, sizeof(nulls));
+
+	/* Initialise attributes information in the tuple descriptor */
+	tupdesc = CreateTemplateTupleDesc(PG_STAT_NETWORK_TRAFFIC_COLS);
+	TupleDescInitEntry(tupdesc, (AttrNumber) 1, "rx_raw_bytes",
+					   INT8OID, -1, 0);
+	TupleDescInitEntry(tupdesc, (AttrNumber) 2, "tx_raw_bytes",
+					   INT8OID, -1, 0);
+	TupleDescInitEntry(tupdesc, (AttrNumber) 3, "rx_compressed_bytes",
+					   INT8OID, -1, 0);
+	TupleDescInitEntry(tupdesc, (AttrNumber) 4, "tx_compressed_bytes",
+					   INT8OID, -1, 0);
+	BlessTupleDesc(tupdesc);
+
+	/* Fill values and NULLs */
+	values[0] = beentry->st_rx_raw_bytes;
+	values[1] = beentry->st_tx_raw_bytes;
+	values[2] = beentry->st_rx_compressed_bytes;
+	values[3] = beentry->st_tx_compressed_bytes;
+
+	/* Returns the record as Datum */
+	PG_RETURN_DATUM(HeapTupleGetDatum(heap_form_tuple(tupdesc, values, nulls)));
+}
 
 Datum
 pg_stat_get_backend_client_addr(PG_FUNCTION_ARGS)
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index d2ce4a8450..1f82c89668 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -51,6 +51,7 @@
 #include "commands/vacuum.h"
 #include "commands/variable.h"
 #include "common/string.h"
+#include "common/zpq_stream.h"
 #include "funcapi.h"
 #include "jit/jit.h"
 #include "libpq/auth.h"
@@ -190,6 +191,7 @@ static bool check_stage_log_stats(bool *newval, void **extra, GucSource source);
 static bool check_log_stats(bool *newval, void **extra, GucSource source);
 static bool check_canonical_path(char **newval, void **extra, GucSource source);
 static bool check_timezone_abbreviations(char **newval, void **extra, GucSource source);
+static bool check_libpq_compression(char **newval, void **extra, GucSource source);
 static void assign_timezone_abbreviations(const char *newval, void *extra);
 static void pg_timezone_abbrev_initialize(void);
 static const char *show_archive_command(void);
@@ -4563,6 +4565,16 @@ static struct config_string ConfigureNamesString[] =
 		NULL, NULL, NULL
 	},
 
+	{
+		{"libpq_compression", PGC_SIGHUP, CLIENT_CONN_OTHER,
+			gettext_noop("Sets the list of allowed libpq compression algorithms."),
+			NULL
+		},
+		&libpq_compress_algorithms,
+		"on",
+		check_libpq_compression, NULL, NULL
+	},
+
 	{
 		{"application_name", PGC_USERSET, LOGGING_WHAT,
 			gettext_noop("Sets the application name to be reported in statistics and logs."),
@@ -4994,6 +5006,8 @@ static struct config_enum ConfigureNamesEnum[] =
 		NULL, NULL, NULL
 	},
 
+
+
 	/* End-of-list marker */
 	{
 		{NULL, 0, 0, NULL, NULL}, NULL, 0, NULL, NULL, NULL, NULL
@@ -11819,6 +11833,22 @@ check_ssl(bool *newval, void **extra, GucSource source)
 	return true;
 }
 
+static bool
+check_libpq_compression(char **newval, void **extra, GucSource source)
+{
+	zpq_compressor *compressors;
+	size_t		n_compressors;
+
+	if (!zpq_parse_compression_setting(*newval, &compressors, &n_compressors))
+	{
+		GUC_check_errdetail("Cannot parse the libpq_compression setting.");
+		return false;
+	}
+
+	free(compressors);
+	return true;
+}
+
 static bool
 check_stage_log_stats(bool *newval, void **extra, GucSource source)
 {
diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index d6b31bbf53..5f1b4abbda 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -6687,6 +6687,9 @@ threadRun(void *arg)
 		int			nsocks;		/* number of sockets to be waited for */
 		pg_time_usec_t min_usec;
 		pg_time_usec_t now = 0; /* set this only if needed */
+		bool		buffered_rx = false;	/* true if some of the clients has
+											 * data left in SSL/ZPQ read
+											 * buffers */
 
 		/*
 		 * identify which client sockets should be checked for input, and
@@ -6721,6 +6724,9 @@ threadRun(void *arg)
 				 */
 				int			sock = PQsocket(st->con);
 
+				/* check if conn has buffered SSL / ZPQ read data */
+				buffered_rx = buffered_rx || PQreadPending(st->con);
+
 				if (sock < 0)
 				{
 					pg_log_error("invalid socket: %s", PQerrorMessage(st->con));
@@ -6764,7 +6770,7 @@ threadRun(void *arg)
 			{
 				if (nsocks > 0)
 				{
-					rc = wait_on_socket_set(sockets, min_usec);
+					rc = buffered_rx ? 1 : wait_on_socket_set(sockets, min_usec);
 				}
 				else			/* nothing active, simple sleep */
 				{
@@ -6773,7 +6779,7 @@ threadRun(void *arg)
 			}
 			else				/* no explicit delay, wait without timeout */
 			{
-				rc = wait_on_socket_set(sockets, 0);
+				rc = buffered_rx ? 1 : wait_on_socket_set(sockets, 0);
 			}
 
 			if (rc < 0)
@@ -6812,8 +6818,11 @@ threadRun(void *arg)
 					pg_log_error("invalid socket: %s", PQerrorMessage(st->con));
 					goto done;
 				}
-
-				if (!socket_has_input(sockets, sock, nsocks++))
+				if (PQreadPending(st->con))
+				{
+					nsocks++;
+				}
+				else if (!socket_has_input(sockets, sock, nsocks++))
 					continue;
 			}
 			else if (st->state == CSTATE_FINISHED ||
diff --git a/src/bin/psql/command.c b/src/bin/psql/command.c
index 49d4c0e3ce..bc913adf55 100644
--- a/src/bin/psql/command.c
+++ b/src/bin/psql/command.c
@@ -169,6 +169,7 @@ static void print_with_linenumbers(FILE *output, char *lines,
 								   const char *header_keyword);
 static void minimal_error_message(PGresult *res);
 
+static void printCompressionInfo(void);
 static void printSSLInfo(void);
 static void printGSSInfo(void);
 static bool printPsetInfo(const char *param, printQueryOpt *popt);
@@ -629,6 +630,7 @@ exec_command_conninfo(PsqlScanState scan_state, bool active_branch)
 					printf(_("You are connected to database \"%s\" as user \"%s\" on host \"%s\" at port \"%s\".\n"),
 						   db, PQuser(pset.db), host, PQport(pset.db));
 			}
+			printCompressionInfo();
 			printSSLInfo();
 			printGSSInfo();
 		}
@@ -3582,6 +3584,27 @@ connection_warnings(bool in_startup)
 	}
 }
 
+/*
+ * printCompressionInfo
+ *
+ * Print information about used compressor/decompressor
+ */
+static void
+printCompressionInfo(void)
+{
+	char	   *compressor = PQcompressor(pset.db);
+	char	   *decompressor = PQdecompressor(pset.db);
+
+	if (compressor != NULL)
+	{
+		printf(_("Compressor %s\n"), compressor);
+	}
+
+	if (decompressor != NULL)
+	{
+		printf(_("Decompressor %s\n"), decompressor);
+	}
+}
 
 /*
  * printSSLInfo
diff --git a/src/common/Makefile b/src/common/Makefile
index ab82876cca..9439c25778 100644
--- a/src/common/Makefile
+++ b/src/common/Makefile
@@ -78,7 +78,8 @@ OBJS_COMMON = \
 	username.o \
 	wait_error.o \
 	wchar.o \
-	z_stream.o
+	z_stream.o \
+	zpq_stream.o
 
 ifeq ($(with_ssl),openssl)
 OBJS_COMMON += \
diff --git a/src/common/z_stream.c b/src/common/z_stream.c
index 0f00b0b7fe..0392e745d7 100644
--- a/src/common/z_stream.c
+++ b/src/common/z_stream.c
@@ -84,14 +84,9 @@ typedef struct
 
 struct ZStream
 {
-	ZAlgorithm const *c_algorithm;
-	void	   *c_stream;
-
-	ZAlgorithm const *d_algorithm;
-	void	   *d_stream;
-
-	bool		rx_not_flushed;
-	bool		tx_not_flushed;
+	ZAlgorithm const *algorithm;
+	void	   *stream;
+	bool		not_flushed;
 };
 
 #if HAVE_LIBZSTD
@@ -107,25 +102,32 @@ struct ZStream
 #define ZSTD_WINDOWLOG_LIMIT 23 /* set max window size to 8MB */
 
 
-typedef struct ZPQ_ZSTD_CStream
+typedef struct ZS_ZSTD_CStream
 {
 	ZSTD_CStream *stream;
 	char const *error;			/* error message */
-}			ZPQ_ZSTD_CStream;
+}			ZS_ZSTD_CStream;
 
-typedef struct ZPQ_ZSTD_DStream
+typedef struct ZS_ZSTD_DStream
 {
 	ZSTD_DStream *stream;
 	char const *error;			/* error message */
-}			ZPQ_ZSTD_DStream;
+}			ZS_ZSTD_DStream;
 
 static void *
 zstd_create_compressor(int level)
 {
-	ZPQ_ZSTD_CStream *c_stream = (ZPQ_ZSTD_CStream *) malloc(sizeof(ZPQ_ZSTD_CStream));
+	size_t		rc;
+	ZS_ZSTD_CStream *c_stream = (ZS_ZSTD_CStream *) malloc(sizeof(ZS_ZSTD_CStream));
 
 	c_stream->stream = ZSTD_createCStream();
-	ZSTD_initCStream(c_stream->stream, level);
+	rc = ZSTD_initCStream(c_stream->stream, level);
+	if (ZSTD_isError(rc))
+	{
+		ZSTD_freeCStream(c_stream->stream);
+		free(c_stream);
+		return NULL;
+	}
 #if ZSTD_VERSION_MAJOR > 1 || ZSTD_VERSION_MINOR > 3
 	ZSTD_CCtx_setParameter(c_stream->stream, ZSTD_c_windowLog, ZSTD_WINDOWLOG_LIMIT);
 #endif
@@ -136,10 +138,17 @@ zstd_create_compressor(int level)
 static void *
 zstd_create_decompressor()
 {
-	ZPQ_ZSTD_DStream *d_stream = (ZPQ_ZSTD_DStream *) malloc(sizeof(ZPQ_ZSTD_DStream));
+	size_t		rc;
+	ZS_ZSTD_DStream *d_stream = (ZS_ZSTD_DStream *) malloc(sizeof(ZS_ZSTD_DStream));
 
 	d_stream->stream = ZSTD_createDStream();
-	ZSTD_initDStream(d_stream->stream);
+	rc = ZSTD_initDStream(d_stream->stream);
+	if (ZSTD_isError(rc))
+	{
+		ZSTD_freeDStream(d_stream->stream);
+		free(d_stream);
+		return NULL;
+	}
 #if ZSTD_VERSION_MAJOR > 1 || ZSTD_VERSION_MINOR > 3
 	ZSTD_DCtx_setParameter(d_stream->stream, ZSTD_d_windowLogMax, ZSTD_WINDOWLOG_LIMIT);
 #endif
@@ -150,7 +159,7 @@ zstd_create_decompressor()
 static ssize_t
 zstd_decompress(void *d_stream, void const *src, size_t src_size, size_t *src_processed, void *dst, size_t dst_size, size_t *dst_processed)
 {
-	ZPQ_ZSTD_DStream *ds = (ZPQ_ZSTD_DStream *) d_stream;
+	ZS_ZSTD_DStream *ds = (ZS_ZSTD_DStream *) d_stream;
 	ZSTD_inBuffer in;
 	ZSTD_outBuffer out;
 	size_t		rc;
@@ -192,7 +201,7 @@ zstd_decompress(void *d_stream, void const *src, size_t src_size, size_t *src_pr
 static ssize_t
 zstd_compress(void *c_stream, void const *src, size_t src_size, size_t *src_processed, void *dst, size_t dst_size, size_t *dst_processed)
 {
-	ZPQ_ZSTD_CStream *cs = (ZPQ_ZSTD_CStream *) c_stream;
+	ZS_ZSTD_CStream *cs = (ZS_ZSTD_CStream *) c_stream;
 	ZSTD_inBuffer in;
 	ZSTD_outBuffer out;
 
@@ -236,7 +245,7 @@ static ssize_t
 zstd_end(void *c_stream, void *dst, size_t dst_size, size_t *dst_processed)
 {
 	size_t		tx_not_flushed;
-	ZPQ_ZSTD_CStream *cs = (ZPQ_ZSTD_CStream *) c_stream;
+	ZS_ZSTD_CStream *cs = (ZS_ZSTD_CStream *) c_stream;
 	ZSTD_outBuffer output;
 
 	output.dst = dst;
@@ -260,7 +269,7 @@ zstd_end(void *c_stream, void *dst, size_t dst_size, size_t *dst_processed)
 static void
 zstd_free_compressor(void *c_stream)
 {
-	ZPQ_ZSTD_CStream *cs = (ZPQ_ZSTD_CStream *) c_stream;
+	ZS_ZSTD_CStream *cs = (ZS_ZSTD_CStream *) c_stream;
 
 	if (cs != NULL)
 	{
@@ -272,7 +281,7 @@ zstd_free_compressor(void *c_stream)
 static void
 zstd_free_decompressor(void *d_stream)
 {
-	ZPQ_ZSTD_DStream *ds = (ZPQ_ZSTD_DStream *) d_stream;
+	ZS_ZSTD_DStream *ds = (ZS_ZSTD_DStream *) d_stream;
 
 	if (ds != NULL)
 	{
@@ -284,7 +293,7 @@ zstd_free_decompressor(void *d_stream)
 static char const *
 zstd_compress_error(void *c_stream)
 {
-	ZPQ_ZSTD_CStream *cs = (ZPQ_ZSTD_CStream *) c_stream;
+	ZS_ZSTD_CStream *cs = (ZS_ZSTD_CStream *) c_stream;
 
 	return cs->error;
 }
@@ -292,7 +301,7 @@ zstd_compress_error(void *c_stream)
 static char const *
 zstd_decompress_error(void *d_stream)
 {
-	ZPQ_ZSTD_DStream *ds = (ZPQ_ZSTD_DStream *) d_stream;
+	ZS_ZSTD_DStream *ds = (ZS_ZSTD_DStream *) d_stream;
 
 	return ds->error;
 }
@@ -469,7 +478,7 @@ no_compression_name(void)
 /*
  * Array with all supported compression algorithms.
  */
-static ZAlgorithm const zpq_algorithms[] =
+static ZAlgorithm const zs_algorithms[] =
 {
 #if HAVE_LIBZSTD
 	{zstd_name, zstd_create_compressor, zstd_create_decompressor, zstd_decompress, zstd_compress, zstd_free_compressor, zstd_free_decompressor, zstd_compress_error, zstd_decompress_error, zstd_end},
@@ -480,12 +489,22 @@ static ZAlgorithm const zpq_algorithms[] =
 	{no_compression_name}
 };
 
+inline bool
+zs_is_valid_impl_id(unsigned int id)
+{
+	return id >= 0 && id < (sizeof(zs_algorithms) / sizeof(*zs_algorithms));
+}
+
 static ssize_t
-zpq_init_compressor(ZStream * zs, int c_alg_impl, int c_level)
+zs_init_compressor(ZStream * zs, unsigned int c_alg_impl, int c_level)
 {
-	zs->c_algorithm = &zpq_algorithms[c_alg_impl];
-	zs->c_stream = zpq_algorithms[c_alg_impl].create_compressor(c_level);
-	if (zs->c_stream == NULL)
+	if (!zs_is_valid_impl_id(c_alg_impl))
+	{
+		return -1;
+	}
+	zs->algorithm = &zs_algorithms[c_alg_impl];
+	zs->stream = zs->algorithm->create_compressor(c_level);
+	if (zs->stream == NULL)
 	{
 		return -1;
 	}
@@ -493,11 +512,15 @@ zpq_init_compressor(ZStream * zs, int c_alg_impl, int c_level)
 }
 
 static ssize_t
-zpq_init_decompressor(ZStream * zs, int d_alg_impl)
+zs_init_decompressor(ZStream * zs, unsigned int d_alg_impl)
 {
-	zs->d_algorithm = &zpq_algorithms[d_alg_impl];
-	zs->d_stream = zpq_algorithms[d_alg_impl].create_decompressor();
-	if (zs->d_stream == NULL)
+	if (!zs_is_valid_impl_id(d_alg_impl))
+	{
+		return -1;
+	}
+	zs->algorithm = &zs_algorithms[d_alg_impl];
+	zs->stream = zs->algorithm->create_decompressor();
+	if (zs->stream == NULL)
 	{
 		return -1;
 	}
@@ -505,17 +528,32 @@ zpq_init_decompressor(ZStream * zs, int d_alg_impl)
 }
 
 /*
- * Index of used compression algorithm in zpq_algorithms array.
+ * Index of used compression algorithm in zs_algorithms array.
  */
 ZStream *
-zs_create(int c_alg_impl, int c_level, int d_alg_impl)
+zs_create_compressor(unsigned int c_alg_impl, int c_level)
 {
 	ZStream    *zs = (ZStream *) malloc(sizeof(ZStream));
 
-	zs->tx_not_flushed = false;
-	zs->rx_not_flushed = false;
+	zs->not_flushed = false;
 
-	if (zpq_init_compressor(zs, c_alg_impl, c_level) || zpq_init_decompressor(zs, d_alg_impl))
+	if (zs_init_compressor(zs, c_alg_impl, c_level))
+	{
+		free(zs);
+		return NULL;
+	}
+
+	return zs;
+}
+
+ZStream *
+zs_create_decompressor(unsigned int d_alg_impl)
+{
+	ZStream    *zs = (ZStream *) malloc(sizeof(ZStream));
+
+	zs->not_flushed = false;
+
+	if (zs_init_decompressor(zs, d_alg_impl))
 	{
 		free(zs);
 		return NULL;
@@ -528,17 +566,18 @@ ssize_t
 zs_read(ZStream * zs, void const *src, size_t src_size, size_t *src_processed, void *dst, size_t dst_size, size_t *dst_processed)
 {
 	ssize_t		rc;
+
 	*src_processed = 0;
 	*dst_processed = 0;
 
-	rc = zs->d_algorithm->decompress(zs->d_stream,
-									 src, src_size, src_processed,
-									 dst, dst_size, dst_processed);
+	rc = zs->algorithm->decompress(zs->stream,
+								   src, src_size, src_processed,
+								   dst, dst_size, dst_processed);
 
-	zs->rx_not_flushed = false;
+	zs->not_flushed = false;
 	if (rc == ZS_DATA_PENDING)
 	{
-		zs->rx_not_flushed = true;
+		zs->not_flushed = true;
 		return ZS_OK;
 	}
 
@@ -554,17 +593,18 @@ ssize_t
 zs_write(ZStream * zs, void const *buf, size_t size, size_t *processed, void *dst, size_t dst_size, size_t *dst_processed)
 {
 	ssize_t		rc;
+
 	*processed = 0;
 	*dst_processed = 0;
 
-	rc = zs->c_algorithm->compress(zs->c_stream,
-								   buf, size, processed,
-								   dst, dst_size, dst_processed);
+	rc = zs->algorithm->compress(zs->stream,
+								 buf, size, processed,
+								 dst, dst_size, dst_processed);
 
-	zs->tx_not_flushed = false;
+	zs->not_flushed = false;
 	if (rc == ZS_DATA_PENDING)
 	{
-		zs->tx_not_flushed = true;
+		zs->not_flushed = true;
 		return ZS_OK;
 	}
 	if (rc != ZS_OK)
@@ -576,34 +616,50 @@ zs_write(ZStream * zs, void const *buf, size_t size, size_t *processed, void *ds
 }
 
 void
-zs_free(ZStream * zs)
+zs_compressor_free(ZStream * zs)
 {
-	if (zs)
+	if (zs == NULL)
 	{
-		if (zs->c_stream)
-		{
-			zs->c_algorithm->free_compressor(zs->c_stream);
-		}
-		if (zs->d_stream)
-		{
-			zs->d_algorithm->free_decompressor(zs->d_stream);
-		}
-		free(zs);
+		return;
+	}
+
+	if (zs->stream)
+	{
+		zs->algorithm->free_compressor(zs->stream);
 	}
+
+	free(zs);
+}
+
+void
+zs_decompressor_free(ZStream * zs)
+{
+	if (zs == NULL)
+	{
+		return;
+	}
+
+	if (zs->stream)
+	{
+		zs->algorithm->free_decompressor(zs->stream);
+	}
+
+	free(zs);
 }
 
 ssize_t
-zs_end(ZStream * zs, void *dst, size_t dst_size, size_t *dst_processed)
+zs_end_compression(ZStream * zs, void *dst, size_t dst_size, size_t *dst_processed)
 {
 	ssize_t		rc;
+
 	*dst_processed = 0;
 
-	rc = zs->c_algorithm->end_compression(zs->c_stream, dst, dst_size, dst_processed);
+	rc = zs->algorithm->end_compression(zs->stream, dst, dst_size, dst_processed);
 
-	zs->tx_not_flushed = false;
+	zs->not_flushed = false;
 	if (rc == ZS_DATA_PENDING)
 	{
-		zs->tx_not_flushed = true;
+		zs->not_flushed = true;
 		return ZS_OK;
 	}
 	if (rc != ZS_OK)
@@ -617,26 +673,21 @@ zs_end(ZStream * zs, void *dst, size_t dst_size, size_t *dst_processed)
 char const *
 zs_compress_error(ZStream * zs)
 {
-	return zs->c_algorithm->compress_error(zs->c_stream);
+	return zs->algorithm->compress_error(zs->stream);
 }
 
 char const *
 zs_decompress_error(ZStream * zs)
 {
-	return zs->d_algorithm->decompress_error(zs->d_stream);
+	return zs->algorithm->decompress_error(zs->stream);
 }
 
 bool
-zs_buffered_rx(ZStream * zs)
+zs_buffered(ZStream * zs)
 {
-	return zs ? zs->rx_not_flushed : 0;
+	return zs ? zs->not_flushed : 0;
 }
 
-bool
-zs_buffered_tx(ZStream * zs)
-{
-	return zs ? zs->tx_not_flushed : 0;
-}
 
 /*
  * Get list of the supported algorithms.
@@ -644,12 +695,12 @@ zs_buffered_tx(ZStream * zs)
 char	  **
 zs_get_supported_algorithms(void)
 {
-	size_t		n_algorithms = sizeof(zpq_algorithms) / sizeof(*zpq_algorithms);
+	size_t		n_algorithms = sizeof(zs_algorithms) / sizeof(*zs_algorithms);
 	char	  **algorithm_names = malloc(n_algorithms * sizeof(char *));
 
 	for (size_t i = 0; i < n_algorithms; i++)
 	{
-		algorithm_names[i] = (char *) zpq_algorithms[i].name();
+		algorithm_names[i] = (char *) zs_algorithms[i].name();
 	}
 
 	return algorithm_names;
@@ -658,11 +709,11 @@ zs_get_supported_algorithms(void)
 char const *
 zs_compress_algorithm_name(ZStream * zs)
 {
-	return zs ? zs->c_algorithm->name() : NULL;
+	return zs ? zs->algorithm->name() : NULL;
 }
 
 char const *
 zs_decompress_algorithm_name(ZStream * zs)
 {
-	return zs ? zs->d_algorithm->name() : NULL;
+	return zs ? zs->algorithm->name() : NULL;
 }
